<?
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

error_reporting(0);

require("/etc/lms/main.php");
require("/etc/lms/lms-subsys-filtering.conf");

if (!$config['filter_enable'])
{
	exec("/usr/sbin/lms-filtering-clear");
	exit();
}

define('DFTK_ROOT_PATH', "/usr/share/dftk/");
define('LMS_ROOT_PATH', "/usr/share/lms-core-api/");

require_once(LMS_ROOT_PATH."inc.php");
require_once(LMS_ROOT_PATH."unix/inc.php");
require_once(LMS_ROOT_PATH."hosts/inc.php");

$langmgr =& new DftkDaLanguageManager();
$resultmgr =& new DftkDaTraceManager($langmgr);

$con =& new DftkLdapConnection($resultmgr);
$con->set_wrapping_parameter($config[base], "ou=Users", "ou=CommonUsers", "ou=AdminUsers", "ou=ServiceUsers");

$r =& $con->connect($config[server], true);
if (!$r->has_error())
{
	$r =& $con->bind($config[login], $config[passwd]);
	if (!$r->has_error())
	{

		$usermgr =& new LmsUserManager($resultmgr, $con);
		$ugrpmgr =& new LmsUnixGroupManager($resultmgr, $con);
		$err = false;

		$user_list = array();

		if ($config['filter_check_contrib'])
			$r =& $usermgr->get_list(LMS_UTYPE_UNKNOWN, null, "(|(&(objectclass=lmscommonuser)(contributionispaid=1))(objectclass=lmsadminuser))");
		else
			$r =& $usermgr->get_list(LMS_UTYPE_UNKNOWN, null, "(|(objectclass=lmscommonuser)(objectclass=lmsadminuser))");
		if ($r->has_error())
			$err = true;
		$nb = $r->get_result('count');
		
		for ($i=0; $i<$nb; $i++)
		{
			$r =& $usermgr->select_result($i);
			if ($r->has_error())
				$err = true;
			$user_list[] = $r->get_result('uidnumber');
		}

		$hostmgr =& new LmsHostManager($resultmgr, $con);
		$r =& $hostmgr->get_list(LMS_HTYPE_UNKNOWN, array('macaddress', 'owneruid'));
		if ($r->has_error())
			$err = true;
		$nb = $r->get_result('count');


		$fp = fopen("/var/lib/lms-subsys-filtering/ban.sh", "w");
		fwrite($fp, "\n");
		fwrite($fp, "/sbin/iptables -t mangle -P PREROUTING ACCEPT\n");
		fwrite($fp, "/sbin/iptables -t mangle -F\n\n");
		fwrite($fp, "/sbin/iptables -t mangle -I PREROUTING -d 127.0.0.0/8 -j ACCEPT\n\n");
		fwrite($fp, "/sbin/iptables -t mangle -I PREROUTING -i lo -j ACCEPT\n\n");

		$nbz = 0;
		for ($i=0; $i<$nb; $i++)
		{
			$r =& $hostmgr->select_result($i);
			if ($r->has_error())
				$err = true;
			if (in_array($r->get_result('owneruid'), $user_list))
			{
				$mac = $r->get_result('macaddress');
				for ($j=0; $j<count($mac); $j++)
				{
					fwrite($fp, "/sbin/iptables -t mangle -I PREROUTING -m mac --mac-source ".$mac[$j]." -j ACCEPT\n");
					$nbz++;
				}
			}
		}

		fwrite($fp, "\n");
		if (($nbz==0) || $err)
		{
			fwrite($fp, "# LDAP Problem !!!\n");
			fwrite($fp, "/sbin/iptables -t mangle -P PREROUTING ACCEPT\n");
		}
		else
			fwrite($fp, "/sbin/iptables -t mangle -P PREROUTING DROP\n");
		fwrite($fp, "\n");
		fclose($fp);
	}
	else
		print($r->get_debug_msg(true));

	$con->disconnect();
}
else
	print($r->get_debug_msg(true));

unset($con);

if (!$config['filter_gen_only'])
{
	exec("/bin/bash /var/lib/lms-subsys-filtering/ban.sh");
}

?>
